#pragma once

#include "MediaData.h"
#include "TsMedia.h"
#include "TsUtilClass.h"
#include "AacDecoder.h"


// ev[g
#define AACDECFILTER_NAME	(L"AAC Decoder Filter")


// ̃tB^GUID {8D1E3E25-D92B-4849-8D38-C787DA78352C}
DEFINE_GUID(CLSID_AACDECFILTER, 0x8d1e3e25, 0xd92b, 0x4849, 0x8d, 0x38, 0xc7, 0x87, 0xda, 0x78, 0x35, 0x2c);

// tB^̊OQƐ錾
//extern const AMOVIESETUP_FILTER g_AacDecFilterInfo;

class CAacDecFilter :	public CTransformFilter,
						protected CAacDecoder::IPcmHandler
{
public:
	DECLARE_IUNKNOWN

	static IBaseFilter* WINAPI CreateInstance(LPUNKNOWN pUnk, HRESULT *phr);

// CTransformFilter
	HRESULT CheckInputType(const CMediaType* mtIn);
	HRESULT CheckTransform(const CMediaType* mtIn, const CMediaType* mtOut);
	HRESULT DecideBufferSize(IMemAllocator * pAllocator, ALLOCATOR_PROPERTIES *pprop);
	HRESULT GetMediaType(int iPosition, CMediaType *pMediaType);
	HRESULT StartStreaming(void);
	HRESULT StopStreaming(void);
	HRESULT BeginFlush(void);
	HRESULT Receive(IMediaSample *pSample);

// CAacDecFilter
	enum {
		CHANNEL_DUALMONO	= 0x00,
		CHANNEL_INVALID		= 0xFF
	};
	const BYTE GetCurrentChannelNum();

	// Append by HDUSTest̒̐l
	bool ResetDecoder();
	enum { STEREOMODE_STEREO, STEREOMODE_LEFT, STEREOMODE_RIGHT };
	bool SetStereoMode(int StereoMode);
	int GetStereoMode() const { return m_StereoMode; }
	bool SetDownMixSurround(bool bDownMix);
	bool GetDownMixSurround() const { return m_bDownMixSurround; }
	bool SetGainControl(bool bGainControl, float Gain = 1.0f, float SurroundGain = 1.0f);
	bool GetGainControl(float *pGain = NULL, float *pSurroundGain = NULL) const;

	bool SetAdjustStreamTime(bool bAdjust);

	typedef void (CALLBACK *StreamCallback)(short *pData, DWORD Samples, int Channels, void *pParam);
	bool SetStreamCallback(StreamCallback pCallback, void *pParam = NULL);

	DWORD GetBitRate() const;

protected:
	CAacDecFilter(LPUNKNOWN pUnk, HRESULT *phr);
	~CAacDecFilter(void);

	CCritSec m_cStateLock;
	HRESULT Transform(IMediaSample *pIn, IMediaSample *pOut);

// CAacDecoder::IPcmHandler
	virtual void OnPcmFrame(const CAacDecoder *pAacDecoder, const BYTE *pData, const DWORD dwSamples, const BYTE byChannel);

// CAacDecFilter
	CAdtsParser m_AdtsParser;
	CAacDecoder m_AacDecoder;
	CMediaType m_MediaType;
	IMediaSample *m_pOutSample;
	BYTE m_byCurChannelNum;
	bool m_bDualMono;

private:
	const DWORD DownMixMono(short *pDst, const short *pSrc, const DWORD dwSamples);
	const DWORD DownMixStereo(short *pDst, const short *pSrc, const DWORD dwSamples);
	const DWORD DownMixSurround(short *pDst, const short *pSrc, const DWORD dwSamples);
	const DWORD MapSurroundChannels(short *pDst, const short *pSrc, const DWORD dwSamples);

	// Append by HDUSTest̒̐l
	int m_StereoMode;
	bool m_bDownMixSurround;

	bool m_bGainControl;
	float m_Gain;
	float m_SurroundGain;
	void GainControl(short *pBuffer, const DWORD Samples, const float Gain);

	StreamCallback m_pStreamCallback;
	void *m_pStreamCallbackParam;

	bool m_bAdjustStreamTime;
	REFERENCE_TIME m_StartTime;
	LONGLONG m_SampleCount;

	CBitRateCalculator m_BitRateCalculator;
};
